﻿# -*- coding: utf-8 -*-

from brownie import System

#=============================================================================

class Proxy(object):
    __slots__ = ()

    def __getattr__(self, name):
        target = self()
        if target:
            return getattr(target, name)

    def __setattr__(self, name, value):
        target = self()
        if target:
            setattr(target, name, value)

class ThreadForm(Proxy):
    def __call__(self):
        return System.window()

class ThreadView(Proxy):
    def __call__(self):
        form = System.window()
        if form:
            return form.focus
        return None

#=============================================================================

form = ThreadForm()
current = ThreadView()
