// alert.cpp

#include "stdafx.h"
#include "alert.hpp"
#include "hwnd.hpp"
#include "shell.hpp"
#include "system.hpp"

using namespace brownie;

namespace
{
	// FIXME: XbhƂ̃CX^Xɂ΁AO[oϐɂKv͂ȂB
	DWORD	theAlertThreadId;
	HHOOK	theAlertHook;

	LRESULT CALLBACK AlertProc(HWND hwnd, UINT msg, WPARAM wParam, LPARAM lParam, UINT_PTR uIdSubclass, DWORD_PTR)
	{
		LRESULT lResult = DefSubclassProc(hwnd, msg, wParam, lParam);

		switch (msg)
		{
		case WM_INITDIALOG:
			CenterWindow(hwnd);
			RemoveWindowSubclass(hwnd, AlertProc, uIdSubclass);
			break;
		}

		return lResult;
	}

	bool IsMessageBox(HWND hwnd)
	{
		WCHAR clsname[7];
		return ::GetClassName(hwnd, clsname, 7) && wcscmp(L"#32770", clsname) == 0;
	}

	LRESULT CALLBACK AlertHook(int code, WPARAM wParam, LPARAM lParam)
	{
		HHOOK hook = theAlertHook;
		CWPRETSTRUCT* msg = (CWPRETSTRUCT*)lParam;
		if (WM_NCCREATE == msg->message && IsMessageBox(msg->hwnd))
		{
			::SetWindowSubclass(msg->hwnd, AlertProc, 0, 0);
			::UnhookWindowsHookEx(theAlertHook);
			theAlertHook = null;
		}
		return ::CallNextHookEx(hook, code, wParam, lParam);
	}
}

int brownie::Alert(PCWSTR message, PCWSTR title, UINT type) throw()
{
	if (empty(message))
	{
		::MessageBeep(type);
		return 0;
	}
	else
	{
		if (empty(title))
			title = APPNAME;
		::ReleaseCapture();	// Ô߁B

		int		ret;
		HWND	parent = System::GetWindow();

		if (parent && !theAlertHook)
		{
			DWORD thread = GetCurrentThreadId();
			theAlertThreadId = thread;
			theAlertHook = ::SetWindowsHookEx(WH_CALLWNDPROCRET, AlertHook, GetModuleHandle(null), thread);
			ret = ::MessageBox(parent, message, title, type);
			if (theAlertHook && theAlertThreadId == thread)
			{
				::UnhookWindowsHookEx(theAlertHook);
				theAlertHook = null;
			}
		}
		else
		{
			ret = ::MessageBox(null, message, title, type);
		}
		return ret;
	}
}

int brownie::Alert(UINT id, DLGPROC proc, LPARAM param) throw()
{
	return (int)::DialogBoxParam(System::Module, MAKEINTRESOURCE(id), System::GetWindow(), proc, param);
}

int brownie::alert(PCWSTR message, PCWSTR title, UINT type) throw()
{
	py::Unlock unlock;
	return Alert(message, title, type);
}

int brownie::alert(Unicode* message, Unicode* title, UINT type) throw()
{
	return alert(str(message), str(title), type);
}

int brownie::alert(PyObject* message, PyObject* title, UINT type) throw()
{
	return alert(cast<unicode>(message), cast<unicode>(title), type);
}

int brownie::alert(UINT id, DLGPROC proc, LPARAM param) throw()
{
	py::Unlock unlock;
	return Alert(id, proc, param);
}

void brownie::Beep(UINT type) throw()
{
	::MessageBeep(type);
}

// path  pX܂̓WXgL[
void brownie::Beep(PCWSTR path) throw()
{
	WCHAR filename[MAX_PATH];

	if (PathIsRelative(path))
		if SUCCEEDED(RegGetString(HKEY_CURRENT_USER, path, null, filename, MAX_PATH))
			path = filename;

	if (PathFileExists(path))
		::PlaySound(path, null, SND_FILENAME | SND_ASYNC | SND_NOWAIT);
}

void brownie::beep(PyObject* o)
{
	if (is<Null>(o))
		Beep(0U);
	else if (is<Integer>(o))
		Beep(cast<int>(o));
	else
		Beep(str(cast<unicode>(o)));
}

PyObject* brownie::alert(PyObject*, PyObject* args) throw()
{
	try
	{
		PyObject* message = null;
		PyObject* title = null;
		int type = MB_OK;
		parse(static_cast<Tuple*>(args), "O|Oi", &message, &title, &type);
		return cast<integer>(alert(message, title, type)).detach();
	}
	catch (Exception&)
	{
		return null;
	}
}

PyObject* brownie::beep(PyObject*, PyObject* args) throw()
{
	try
	{
		PyObject* what = null;
		parse(static_cast<Tuple*>(args), "|O", &what);
		brownie::beep(what);
		Py_RETURN_NONE;
	}
	catch (Exception&)
	{
		return null;
	}
}
