// registry.cpp

#include "stdafx.h"
#include "brownie.hpp"
#include "shell.hpp"

using namespace brownie;

//==============================================================================
// WXg֐.

HRESULT brownie::RegGetDWORD(HKEY hKey, PCWSTR subkey, PCWSTR value, DWORD* outDWORD)
{
	if (!outDWORD)
		return E_POINTER;
	DWORD type = REG_DWORD;
	DWORD bufSize = sizeof(DWORD);
	DWORD dwResult = SHGetValue(hKey, subkey, value, &type, &outDWORD, &bufSize);
	if (dwResult == ERROR_SUCCESS)
		return S_OK;
	else
		return HRESULT_FROM_WIN32(dwResult);
}

HRESULT brownie::RegSetDWORD(HKEY hKey, PCWSTR subkey, PCWSTR value, DWORD  inDWORD)
{
	DWORD dwResult = SHSetValue(hKey, subkey, value, REG_DWORD, &inDWORD, sizeof(DWORD));
	if (dwResult == ERROR_SUCCESS)
		return S_OK;
	else
		return HRESULT_FROM_WIN32(dwResult);
}

HRESULT brownie::RegGetString(HKEY hKey, PCWSTR subkey, PCWSTR value, WCHAR outString[], size_t cch)
{
	if (!outString)
		return E_POINTER;
	DWORD type = REG_SZ;
	DWORD bufSize = (DWORD)(sizeof(WCHAR) * cch);
	DWORD dwResult = SHGetValueW(hKey, subkey, value, &type, outString, &bufSize);
	if (dwResult == ERROR_SUCCESS)
		return S_OK;
	else
		return HRESULT_FROM_WIN32(dwResult);
}

//==============================================================================

namespace
{
	HRESULT RegGetAssocCommand(PCWSTR key, WCHAR command[MAX_PATH])
	{
		HRESULT hr;
		WCHAR def[MAX_PATH], buffer[MAX_PATH];
		if (empty(key))
			return HRESULT_FROM_WIN32(ERROR_REGISTRY_IO_FAILED);
		// ftHgR}h擾
		wsprintf(buffer, L"%s\\shell", key);
		if (FAILED(RegGetString(HKEY_CLASSES_ROOT, buffer, null, def, MAX_PATH)) || empty(def))
			lstrcpy(def, L"open");
		// R}h̓e擾
		wsprintf(buffer, L"%s\\shell\\%s\\command", key, def);
		if FAILED(hr = RegGetString(HKEY_CLASSES_ROOT, buffer, null, command, MAX_PATH))
			return hr;
		if (empty(command))
			return HRESULT_FROM_WIN32(ERROR_REGISTRY_IO_FAILED);
		return S_OK;
	}
}

// ǂ݂t@CłȂƃG[ɂȂ̂ŎgȂI
//	if (FindExecutable(s, null, exe) > (HINSTANCE)32)
//	if SUCCEEDED(hr = AssocQueryString(ASSOCF_OPEN_BYEXENAME | ASSOCF_NOTRUNCATE, ASSOCSTR_EXECUTABLE, s, L"open"), exe, &ln))
HRESULT brownie::RegGetAssocExe(PCWSTR extension, WCHAR exe[MAX_PATH])
{
	HRESULT hr;
	WCHAR key[MAX_PATH], command[MAX_PATH];

	if FAILED(RegGetAssocCommand(extension, command))
	{
		if (FAILED(hr = RegGetString(HKEY_CLASSES_ROOT, extension, null, key, MAX_PATH))
		|| FAILED(hr = RegGetAssocCommand(key, command)))
			return hr;
	}

	// A'EXE "%1"' 낤̂ŁA͂߂̃Gg擾
	PCWSTR src = command;
	WCHAR delim = L' ';
	if (src[0] == L'"')
	{
		++src; 
		delim = L'\"';
	}
	PWSTR dst = exe;
	while (*src != L'\0' && *src != delim) { *dst++ = *src++; }
	*dst = L'\0';
	return S_OK;
}
