// xp_class.hpp
#pragma once

#include "ref.hpp"

//==================================================================================================================================================================

namespace brownie
{
	//==================================================================================================================================================================
	// IFileOperationXp

	[ uuid("CA1BD5AA-C514-418B-B8CF-1926322967F1") ]
	__interface IFileOperationXp : IFileOperation
	{
		STDMETHODIMP RenameItem(PCWSTR item, PCWSTR name);
		STDMETHODIMP MoveItem(PCWSTR item, PCWSTR path);
		STDMETHODIMP MoveItems(size_t num, PCWSTR items[], PCWSTR folder);
		STDMETHODIMP CopyItem(PCWSTR item, PCWSTR path);
		STDMETHODIMP CopyItems(size_t num, PCWSTR items[], PCWSTR folder);
		STDMETHODIMP DeleteItem(PCWSTR item);
		STDMETHODIMP DeleteItems(size_t num, PCWSTR items[]);
		STDMETHODIMP NewItem(PCWSTR path);
	};

	//==================================================================================================================================================================
	// IFileOperationXp

	const HRESULT S_UPDATED = 0x1234;

	[ uuid("C67197C8-9229-4C12-A27E-86BECC27284F") ]
	__interface IExplorerBrowserXp : IExplorerBrowser
	{
		STDMETHODIMP GetHistory(IShellItem** pp, int mv);
		STDMETHODIMP EnumHistory(IEnumShellItems** pp, int dir);
		STDMETHODIMP BrowseToHistory(int mv);
		STDMETHODIMP SaveViewState();
	};

	//==================================================================================================================================================================
	// IRestartManager

	[ uuid("19E96006-0FA4-44C5-8594-E402E8974100") ]
	__interface IRestartManager : IUnknown
	{
		STDMETHODIMP StartSession(DWORD *pSessionHandle, DWORD dwSessionFlags, WCHAR strSessionKey[]);
		STDMETHODIMP JoinSession(DWORD *pSessionHandle, const WCHAR strSessionKey[]);
		STDMETHODIMP EndSession(DWORD dwSessionHandle);
		STDMETHODIMP RegisterResources(DWORD dwSessionHandle, UINT nFiles, LPCWSTR rgsFileNames[], UINT nApplications, RM_UNIQUE_PROCESS rgApplications[], UINT nServices, LPCWSTR rgsServiceNames[]);
		STDMETHODIMP GetList(DWORD dwSessionHandle, UINT *pnProcInfoNeeded, UINT *pnProcInfo, RM_PROCESS_INFO rgAffectedApps[], LPDWORD lpdwRebootReasons);
		STDMETHODIMP Shutdown(DWORD dwSessionHandle, ULONG lActionFlags, RM_WRITE_STATUS_CALLBACK fnStatus);
		STDMETHODIMP Restart(DWORD dwSessionHandle, DWORD dwRestartFlags, RM_WRITE_STATUS_CALLBACK fnStatus);
		STDMETHODIMP CancelCurrentTask(DWORD dwSessionHandle);
		STDMETHODIMP AddFilter(DWORD dwSessionHandle, LPCWSTR strModuleName, RM_UNIQUE_PROCESS *pProcess, LPCWSTR strServiceShortName, RM_FILTER_ACTION FilterAction);
		STDMETHODIMP RemoveFilter(DWORD dwSessionHandle, LPCWSTR strModuleName, RM_UNIQUE_PROCESS *pProcess, LPCWSTR strServiceShortName);
		STDMETHODIMP GetFilterList(DWORD dwSessionHandle, PBYTE pbFilterBuf, DWORD cbFilterBuf, LPDWORD cbFilterBufNeeded);
	};

	//==================================================================================================================================================================
	// factoy functions

	HRESULT XpExplorerBrowserCreate(REFINTF pp);
	HRESULT XpKnownFolderManagerCreate(REFINTF pp);
	HRESULT	XpFileOperationCreate(REFINTF pp);
	HRESULT	XpFileOpenDialogCreate(REFINTF pp);
	HRESULT	XpFileSaveDialogCreate(REFINTF pp);
	HRESULT	XpSharedBitmapCreate(REFINTF pp);
	HRESULT	XpLocalThumbnailCacheCreate(REFINTF pp);
	HRESULT	XpRestartManagerCreate(REFINTF pp);
}
