// alert.hpp
#pragma once

#include "brownie.hpp"

namespace brownie
{
	//==================================================================================================================================================================
	// for native

	int		Alert(PCWSTR message, PCWSTR title, UINT type) throw();
	int		Alert(UINT id, DLGPROC proc, LPARAM param) throw();
	void	Beep(UINT type) throw();
	void	Beep(PCWSTR path) throw();

	//==================================================================================================================================================================
	// for python

	void	beep(PyObject* o);
	int		alert(UINT id, DLGPROC proc, LPARAM param) throw();
	int		alert(PCWSTR message, PCWSTR title, UINT type) throw();
	int		alert(Unicode* message, Unicode* title, UINT type) throw();
	int		alert(PyObject* message, PyObject* title, UINT type) throw();

	//==================================================================================================================================================================
	// for export

	PyObject*	alert(PyObject*, PyObject* args) throw();
	PyObject*	beep(PyObject*, PyObject* args) throw();

	//==================================================================================================================================================================
}
