// class.hpp
#pragma once

#include "py.hpp"

namespace brownie
{
	//==================================================================================================================================================================
	// PyObject 璼ڔhɎgpB
	// class Root : public PyObject  class Root : public Object

	class __declspec(novtable) Object
	{
	public:
		virtual ~Object() throw()	{}

		PyObject* get_self() const throw()
		{
			if (!this)
				return null;
			return (PyObject*)((BYTE*)this - sizeof(PyObject));
		}
		__declspec(property(get=get_self)) PyObject* self;

		void	AddRef() throw()	{ py::AddRef(self); }
		void	Release() throw()	{ py::Release(self); }
		void	Event(PCSTR name, PCSTR format = null, ...) throw();

		void	event(PCSTR name, PCSTR format = null, ...) throw();

	public:
		typedef void	__base__;
		static PyMethodDef*			__method__() throw()	{ return null; }
		static PyGetSetDef*			__member__() throw()	{ return null; }
		static PyNumberMethods*		__number__() throw()	{ return null; }
		static PySequenceMethods*	__sequence__() throw()	{ return null; }
		static PyMappingMethods*	__mapping__() throw()	{ return null; }
		void		__init__(Tuple* args, Dict* kw) throw()	{ }
	};

	inline bool same(PyObject* lhs, PyObject* rhs) throw()	{ return lhs == rhs; }
	inline bool same(Object*   lhs, Object*   rhs) throw()	{ return lhs == rhs; }
	inline bool same(PyObject* lhs, Object*   rhs) throw()	{ return lhs == rhs->self; }
	inline bool same(Object*   lhs, PyObject* rhs) throw()	{ return lhs->self == rhs; }

	//==================================================================================================================================================================
	// class Class<T> -- PyObject pNXhɎgpB
	//	Use { class Sub : Class<Super> } instead of { class Sub : Super }

	template < typename T >
	struct __declspec(novtable) Class : public T
	{
		typedef T	__base__;
		static PCSTR __name__() throw()				{ STATIC_ASSERT(0); }
		static PyMethodDef*	__method__() throw()	{ return null; }
		static PyGetSetDef*	__member__() throw()	{ return null; }
	};

	//==================================================================================================================================================================

	// template < typename T > ? cast(T from);

	// newobj -- Create new python instance.
	template < typename T >
	inline ref<T> newobj(Tuple* args = null)
	{
		PyObject* type = (PyObject*)typeof<T>();
		PyObject* self = PyObject_CallObject(type, args);
		detail::ObjectImpl<T>* o = reinterpret_cast<detail::ObjectImpl<T>*>(self);
		T* r = &o->__self__;
		return ref<T>::from(r);
	}
}

#include "detail/class.inl"
