// clipboard.hpp
#pragma once

#include "class.hpp"

namespace brownie
{
	class Clipboard : public Object
	{
	private:
		bool	m_locked;

	public:
		Clipboard();
		~Clipboard();
		void set_Text(PCWSTR text);

	public: // python
		static PCSTR __name__() throw()					{ return "brownie.Clipboard"; }
		static PyMethodDef* __method__() throw();
		static PyGetSetDef* __member__() throw();

	public: // clipboard viewer
		static bool	OnMessage(HWND hwnd, UINT msg, WPARAM wParam, LPARAM lParam, LRESULT& lResult);

	public:
		void	__enter__();
		void	__exit__(Tuple* args);
		void	clear();
		void	copy_(PCWSTR text);
		void	copy(PyObject* value);
		void	cut(PyObject* value);
		object	get_text();
		void	set_text(PyObject* text);
		tuple	get_file();
		void	set_file(PyObject* files, bool copy);
	};
}
