// dragdrop.hpp
#pragma once

#include "unknown.hpp"
#include "window.hpp"

namespace brownie
{
	class DropTarget : public Unknown< implements<IDropTarget>, mixin<StaticLife> >
	{
	private:
		Window*					m_owner;
		ref<IDataObject>		m_data;
		ref<IDropTarget>		m_target;
		RECT					m_bounds;
		ref<IDropTargetHelper>	m_helper;

	public:
		DropTarget();
		~DropTarget();
		void Register(Window* w);
		void Revoke();

	public: // IDropTarget
		STDMETHODIMP DragEnter(IDataObject* data, DWORD keys, POINTL pt, DWORD* effect);
		STDMETHODIMP DragOver(DWORD keys, POINTL pt, DWORD* effect);
		STDMETHODIMP DragLeave();
		STDMETHODIMP Drop(IDataObject* data, DWORD keys, POINTL pt, DWORD* effect);
	};
}
