// icons.hpp
#pragma once

#include "config.hpp"
#include "class.hpp"
#include "drawing.hpp"

namespace brownie
{
	//==================================================================================================================================================================

	class Icons : public Object
	{
	private:
		HIMAGELIST	m_handle[3];
		HIMAGELIST	m_shImageList;

	public:
		Icons() throw();
		~Icons() throw();

		HIMAGELIST	get_Handle(DWORD status) const throw();
		__declspec(property(get=get_Handle)) HIMAGELIST Handle[];

		int		get_Count() const throw();
		__declspec(property(get=get_Count)) int Count;
		SIZE	get_Size() const throw();
		__declspec(property(get=get_Size)) SIZE Size;

		HICON	Extract(int index);

	public:
		static PCSTR __name__() throw()					{ return "brownie.Icons"; }
		void __init__(Tuple* args, Dict* kw) throw(...);
		static PyGetSetDef* __member__() throw();

	public:
		object	get_count();
		object	get_size();
	};

	bool	IconsDraw(HDC dc, int icon, int x, int y, DWORD status, Icons* icons, HIMAGELIST shImageList) throw();
	SIZE	IconsSize(Icons* icons, HIMAGELIST shImageList, int minW, int minH) throw();
	HIMAGELIST	SHGetImageList(Icons* icons) throw();
}
