// layout.hpp
#pragma once

#include "config.hpp"

namespace brownie
{
	class Window;

	HWND	LayoutGetCenter(const Window* w);
	void	LayoutEnumCenter(const Window* w, std::vector<HWND>& children);
	void	LayoutEnumAll(const Window* w, std::vector<HWND>& children);
	void	LayoutCenterArea(const Window* w, RECT* bounds);
	HWND	LayoutArrange(Window* w, RECT bounds);
	HWND	LayoutFocus(Window* w, DIRECTION dir);

	__interface ILayout
	{
		SIZE	get_Margin() const throw();
		void	set_Margin(SIZE value) throw();
		__declspec(property(get=get_Margin, put=set_Margin)) SIZE Margin;

		void	Insert(HWND hwnd, DIRECTION dock);
	};
}
