// map.hpp
#pragma once

#pragma warning( disable : 4702 )
#include <map>
#pragma warning( default : 4702 )
#include "stream.hpp"

//==============================================================================
// std::map<Key, Mapped, Pred, Alloc>ɑ΂Streamo

template < typename Key, typename Mapped, class Pred, class Alloc >
inline IStream& operator >> (IStream& stream, std::map<Key, Mapped, Pred, Alloc>& v) throw(HRESULT)
{
	UINT32 size;
	stream >> size;
	for (UINT32 i = 0; i < size; ++i)
	{
		std::pair<Key, Mapped> item;
		stream >> item;
		v.insert(v.end(), item);
	}
	return stream;
}

template < typename Key, typename Mapped, class Pred, class Alloc >
inline IStream& operator << (IStream& stream, const std::map<Key, Mapped, Pred, Alloc>& v) throw(HRESULT)
{
	stream << (UINT32)v.size();
	for (std::map<Key, Mapped, Pred, Alloc>::const_iterator i = v.begin(); i != v.end(); ++i)
		stream << *i;
	return stream;
}
