// node.hpp

#include "config.hpp"
#include "py.hpp"

namespace brownie
{
	const HRESULT S_RENAME = 2;		// IContextMenu.Rename IꂽBĂяoőΉ邱ƁB
	const HRESULT S_DEFAULT = 3;	// ftHgڂIꂽBĂяoőΉ邱ƁB

	class Icons;

	//class Node : public PyObject
	//{
	//public:
	//	unicode		name;
	//	iterator	children;
	//	object		execute();
	//	int			icon;
	//	bool		enabled;
	//	bool		disabled;
	//	iterator	menu;
	//};

	unicode		node_get_name(PyObject* node) throw();
	int			node_get_icon(PyObject* node) throw();
	bool		node_has_children(PyObject* node) throw();
	bool		node_executable(PyObject* node) throw();
	bool		node_enabled(PyObject* node) throw();
	bool		node_checked(PyObject* node) throw();
	iterator	node_enum_children(PyObject* node) throw();
	iterator	node_enum_menu(PyObject* node, IContextMenu** pp) throw();
	object		node_execute(PyObject* node, Tuple* args = null, Dict* kw = null) throw();

	PyObject*	popup(PyObject*, PyObject* args, PyObject* kw) throw();
	HRESULT		node_popup(Iterator* iter, IContextMenu* menu, POINT pt, DIRECTION dock, Icons* icons = null) throw();
	HRESULT		node_popup_menu(PyObject* node, POINT pt, Icons* icons) throw();
	HRESULT		node_popup_children(PyObject* node, POINT pt, DIRECTION dock, Icons* icons) throw();

	HRESULT		NodeExecute(PyObject* node, UINT vk = 0, UINT mk = 0) throw();
	HRESULT		NodePopupMenu(PyObject* node, POINT pt, Icons* icons) throw();
	HRESULT		NodePopupChildren(PyObject* node, const RECT& rc, DIRECTION dock, Icons* icons) throw();

	HRESULT		IShellView_Popup(IShellView* view, POINT pt, ICommDlgBrowser2* browser) throw();

	template < typename T >
	inline HRESULT NodePopupChildren(const T* w, PyObject* node, int index)
	{
		RECT rc;
		w->GetItemRect(index, &rc);
		w->ClientToScreen(&rc);
		return NodePopupChildren(node, rc, w->get_Dock(), w->GetIcons());
	}
}
