// system.hpp
#pragma once

#include "class.hpp"

namespace brownie
{
	enum
	{
		WM_FORK	= WM_USER + 1000,	// VUIXbh𐶐B
		WM_SHELL,					// VF̒ʒmB
		WM_RESTART,					// ċN
		WM_ARGUMENTS,				// nꂽ
		WM_ACTIVATEWINDOW,
		WM_PARENTFOCUS,
		WM_MENURCLICK,
	};

	//==================================================================================================================================================================

	typedef unsigned (STDMETHODCALLTYPE *ThreadProc)(void*);

	class System : public Object
	{
	public:
		static HINSTANCE	Module;
		static HWND			Window;

	public:
		static void		Init(WNDPROC wndproc);
		static void		Term();

		static DWORD	Fork(ThreadProc proc, PyObject* fn);
		static void		MessageLoop(HWND hwnd) throw();
		static void		Run();
		static void		ActivateWindow(int dir);
		static HWND		GetWindow() throw();
		static void		Broadcast(UINT msg, WPARAM wParam = 0, LPARAM lParam = 0) throw();

		static void		OnActivate(WPARAM wParam, LPARAM lParam);
		static void		OnHotKey(WPARAM wParam, LPARAM lParam);
		static void		OnSettingChange(WPARAM wParam, LPARAM lParam);

	public: // python
		static PCSTR __name__() throw()					{ return "brownie.System"; }
		static PyMethodDef* __method__() throw();
	//	static PyGetSetDef* __member__() throw();
		static void		activate(Tuple* args);
		static object	window();
		static void		fork(PyObject* o);
		static void		restart();
		static void		quit();

		static object	get_keymap();
		static void		set_keymap(PyObject* o);
	};
}
