// tabbar.hpp
#pragma once

#include "abstractbar.hpp"

namespace brownie
{
	class TabBar : public Class<AbstractBar>
	{
	private:
		Theme	m_theme;
		ssize_t	m_selection;

	public:
		SIZE	get_DefaultSize() const;
		ssize_t	GetSelectedItem() const throw()			{ return m_selection; }
		void	SetSelectedItem(ssize_t index) throw();

	protected:
		LRESULT	OnMessage(UINT msg, WPARAM wParam, LPARAM lParam);
		void	OnLayout();
		void	OnDraw(HDC dc, const RECT& rcPaint);

	public:
		static PCSTR __name__() throw()					{ return "brownie.TabBar"; }
		void	__init__(Tuple* args, Dict* kw) throw(...);
//		static PyMethodDef* __method__() throw();
		static PyGetSetDef* __member__() throw();
		object	get_selection();
		void	set_selection(PyObject* value);
	};
}
