// textview.hpp
#pragma once

#include "commctrl.hpp"
#include "window.hpp"

namespace brownie
{
	class TextBox : public Class<Window>
	{
	public: // python 
		static PCSTR __name__() throw()					{ return "brownie.TextBox"; }
		void __init__(Tuple* args, Dict* kw) throw(...);
		static PyMethodDef* __method__() throw();
		static PyGetSetDef* __member__() throw();
		object	get_selection();
		void	set_selection(PyObject* o);
		void	cut();
		void	copy();
		void	paste();
		void	delete_();
		void	limit(PyObject* o);
		void	undo();
	};

	class TextView : public Class<TextBox>
	{
	public: // python 
		static PCSTR __name__() throw()					{ return "brownie.TextView"; }
		void __init__(Tuple* args, Dict* kw) throw(...);
	};

	class Label : public Class<Window>
	{
	public: // python 
		static PCSTR __name__() throw()					{ return "brownie.Label"; }
		void __init__(Tuple* args, Dict* kw) throw(...);
	};
}
