// thread.hpp
#pragma once

#include "ref.hpp"

namespace brownie
{
	class Window;

	//==================================================================================================================================================================

	class Thread
	{
		friend class Window;
		enum MouseState
		{
			MouseNormal,	// ʏiWFX`ĂȂj
			MouseGesture,	// WFX`
			MouseDisabled,	// }EXG~[V
		};

	private:
		DWORD		m_ID;				// XbhID
		HWND		m_hwnd;				// ̃Xbh̃CEBhE
		WNDPROC		m_wndprocOriginal;	// EBhE쐬ɎgꎞIȕۑ
		HWND		m_hwndLastWheel;	// }EXzC[̃_CNg
		HHOOK		m_hookMSG;
		bool		m_needsUpdate;
		MouseState	m_mouseState;

	public:
		Thread() throw();
		~Thread();

		static Thread* Get() throw();

		HWND	get_Hwnd() const throw()		{ return m_hwnd; }
		void	MessageLoop(HWND hwnd) throw();
		void	DragDrop(UINT mk, POINT from, POINT to) throw();

	private:
		void	Update() throw();
		void	RedirectMouseWheel(MSG& msg);
		bool	OnMouseDown(const MSG& msg) throw();
		bool	OnMouseUp(const MSG& msg) throw();
		void	OnMessage(MSG& msg) throw();
		static LRESULT CALLBACK HookMSG(int code, WPARAM wParam, LPARAM lParam) throw();
	};

	//==================================================================================================================================================================

	class CritialSection
	{
	private:
		CRITICAL_SECTION	m_cs;
	public:
		CritialSection() throw()	{ ::InitializeCriticalSection(&m_cs); }
		void	Enter() throw()		{ ::EnterCriticalSection(&m_cs); }
		void	Leave() throw()		{ ::LeaveCriticalSection(&m_cs); }
	};

	class Lock
	{
	private:
		CritialSection&	m_cs;
	public:
		Lock(CritialSection& cs) : m_cs(cs)		{ m_cs.Enter(); }
		~Lock()									{ m_cs.Leave(); }
	private: // non-copyable
		Lock(const Lock&);
		Lock& operator = (const Lock&);
	};
}
