// toolbar.hpp
#pragma once

#include "window.hpp"
#include "commctrl.hpp"
#include "icons.hpp"
#include "dragdrop.hpp"

namespace brownie
{
	//==================================================================================================================================================================

	class ToolBar : public Class<Window>, public ToolBarT<ToolBar>
	{
	private:
		object		m_icons;
		object		m_items;
		DropTarget	m_drop;

	public:
		void set_Dock(DIRECTION value);
		SIZE get_DefaultSize() const throw();

		Icons*	GetIcons() const throw();
		void	SetIcons(Icons* value) throw();

	protected:
		LRESULT	OnMessage(UINT msg, WPARAM wParam, LPARAM lParam);
		LRESULT	OnMessage(Window* from, NMHDR& nm);
		void	OnUpdate();
		bool	OnGesture(const MSG& msg);
		bool	OnContextMenu(LPARAM lParam);
		void	OnDragDrop(POINT pt, RECT* rc, IDropTarget** pp) throw();

	public:
		void		DropDown(int index);
		PyObject*	GetItem(ssize_t index) const throw();
		void		Clear() throw();

	public:
		static PCSTR __name__() throw()					{ return "brownie.ToolBar"; }
		void __init__(Tuple* args, Dict* kw) throw(...);
//		static PyMethodDef* __method__() throw();
		static PyGetSetDef* __member__() throw();

		void	set_icons(PyObject* value);
		void	set_items(PyObject* value);
		void	clear() throw();

	private:
		bool	OnMouseDown(UINT msg, WPARAM wParam, LPARAM lParam);
	};
}
