// treeview.hpp
#pragma once

#include "window.hpp"
#include "icons.hpp"
#include "commctrl.hpp"

namespace brownie
{
	//==================================================================================================================================================================

	class TreeView : public Class<Window>, public TreeViewT<TreeView>
	{
	private:
		object		m_icons;
		object		m_items;

	public:
		Icons*	GetIcons() const throw();
		void	SetIcons(Icons* value) throw();

	protected:
		LRESULT	OnMessage(UINT msg, WPARAM wParam, LPARAM lParam);
		LRESULT	OnMessage(Window* from, NMHDR& nm);
		bool	OnGesture(const MSG& msg);

	private:
		bool	OnClickExecute(WPARAM wParam, LPARAM lParam, UINT vk);
		bool	OnContextMenu(LPARAM lParam);
		void	OnGetDispInfo(NMTVDISPINFO& disp);
		void	OnExpanding(NMTREEVIEW& nm);
		void	OnExpanded(NMTREEVIEW& nm);
		void	OnDeleteItem(NMTREEVIEW& nm);

	public:
		PyObject*	GetItem(HTREEITEM item) const throw();
		void		Clear() throw();

	public:
		static PCSTR __name__() throw()					{ return "brownie.TreeView"; }
		void __init__(Tuple* args, Dict* kw) throw(...);
//		static PyMethodDef* __method__() throw();
		static PyGetSetDef* __member__() throw();

		void	set_icons(PyObject* value);
		void	set_items(PyObject* value);
		void	clear() throw();
		HTREEITEM	insert(HTREEITEM parent, PyObject* o);
	};
}
