﻿# -*- coding: utf-8 -*-

from brownie import *
import re

re_url = re.compile('(http|mms|rtsp)://[0-9A-Za-z_:./\\-]+')

def _filter_url(url):
    if not url.endswith('/') and url.find('/cm/') < 0:
        return url
    else:
        return None

def url(view):
    "Extract URLs from items"

    items = view.selection
    urls = set()
    for item in items:
        for line in item.open():
            for m in re_url.finditer(line):
                url = _filter_url(m.group())
                if url:
                    urls.add(url)
    if urls:
        Clipboard().text = '\r\n'.join(sorted(urls))
        return ('クリップボードに %d 個のURLをコピーしました。' % len(urls), INFO)
    else:
        return ('ファイル中にURLが見つかりませんでした。', WARNING)
